# -*- coding: utf-8 -*-
import smmp_p as smmp
import mpi4py
import mpi4py.MPI
import time, random
from universe import *
from protein import *
from algorithms import *

smmp.paral.my_mpi_comm = mpi4py.MPI.COMM_WORLD.py2f()
smmp.paral.myrank = mpi4py.MPI.COMM_WORLD.Get_rank()
numberOfTasks = mpi4py.MPI.COMM_WORLD.Get_size()
smmp.paral.no = numberOfTasks
#smmp.init_energy("SMMP/")
#smmp.init_molecule(1,'nh3+','coo-',seqfile='EXAMPLES/1bdd.seq',varfile='EXAMPLES/1bdd.var')
myU = Universe(st=1)
myP = Protein('EXAMPLES/1bdd.seq', 'EXAMPLES/1bdd.var')
myU.add(myP)
smmp.distributeworkload(numberOfTasks,1)
E = myU.energy()
if smmp.paral.myrank == 0:
    print "The starting energy is %s." % E

random.seed(82364)
#myMC = CanonicalMonteCarlo(myU, 20, 20)

t0 = time.time()
for i in xrange(1000):
    myU.energy()

#myMC.run()
t1 = time.time()
E = myU.energy()
if smmp.paral.myrank == 0:
#    Emin = myMC.minimumEnergy()
    print "The final energy is: %f. Calculated in %fs" % (E, (t1 -t0))
#    print "The minimum energy found was %.2f at sweep %s." % Emin
    
print random.random()

